<?php
/** 
Plugin Name: uComment WP Comment Bot
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will generate comments automatically to WordPress blogs.
Author: CodeRevolution
Version: 1.0.9
Author URI: //coderevolution.ro
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: ucomment-wordpress-blog-auto-commenter
*/
/*  
Copyright 2016 - 2020 CodeRevolution
*/
defined('ABSPATH') or die();
require_once (dirname(__FILE__) . "/res/other/plugin-dash.php"); 


function ucomment_load_textdomain() {
    load_plugin_textdomain( 'ucomment-wordpress-blog-auto-commenter', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'ucomment_load_textdomain' );
function ucomments_get_random_user_agent() {
	$agents = array(
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36 Edge/15.15063",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36"
	);
	$rand   = rand( 0, count( $agents ) - 1 );
	return trim( $agents[ $rand ] );
}
$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        update_option('coderevolution_settings_changed', 1);
        if(strlen(trim($_POST[$plugin_slug . '_register_code'])) != 36 || strstr($_POST[$plugin_slug . '_register_code'], '-') == false)
        {
            ucomments_log_to_file('Invalid registration code submitted: ' . $_POST[$plugin_slug . '_register_code']);
        }
        else
        {
            $ch = curl_init('https://wpinitiate.com/verify-purchase/purchase.php');
            if($ch !== false)
            {
                $data           = array();
                $data['code']   = trim($_POST[$plugin_slug . '_register_code']);
                $data['siteURL']   = get_bloginfo('url');
                $data['siteName']   = get_bloginfo('name');
                $data['siteEmail']   = get_bloginfo('admin_email');
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode(trim($val)) . "&";
                }
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                $result = curl_exec($ch);
                
                if($result === false)
                {
                    ucomments_log_to_file('Failed to get verification response: ' . curl_error($ch));
                }
                else
                {
                    if($result == 'error1' || $result == 'error2' || $result == 'error3' || $result == 'error4')
                    {
                        ucomments_log_to_file('Failed to validate plugin info: ' . $result);
                    }
                    else
                    {
                        $rj = json_decode($result, true);
                        if(isset($rj['item_name']))
                        {
                            $rj['code'] = $_POST[$plugin_slug . '_register_code'];
                            if($rj['item_id'] == '22750286' || $rj['item_id'] == '13371337' || $rj['item_id'] == '19200046')
                            {
                                update_option($plugin_slug . '_registration', $rj);
                                update_option('coderevolution_settings_changed', 2);
                            }
                            else
                            {
                                ucomments_log_to_file('Invalid response from purchase code verification (are you sure you inputed the right purchase code?): ' . print_r($rj, true));
                            }
                        }
                        else
                        {
                            ucomments_log_to_file('Invalid json from purchase code verification: ' . print_r($result, true));
                        }
                    }
                }
                curl_close($ch);
            }
            else
            {
                ucomments_log_to_file('Failed to init curl when trying to make purchase verification.');
            }
        }
    }
    $uoptions = get_option($plugin_slug . '_registration', array());
    if(isset($uoptions['item_id']) && isset($uoptions['item_name']) && isset($uoptions['created_at']) && isset($uoptions['buyer']) && isset($uoptions['licence']) && isset($uoptions['supported_until']))
    {
        require "update-checker/plugin-update-checker.php";
        $fwdu3dcarPUC = Puc_v4_Factory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=ucomment-wordpress-blog-auto-commenter", __FILE__, "ucomment-wordpress-blog-auto-commenter");
    }
    else
    {
        add_action("after_plugin_row_{$plugin}", function( $plugin_file, $plugin_data, $status ) {
            $plugin_url = 'https://codecanyon.net/item/ucomment-wp-comment-bot-plugin-for-wordpress/22750286';
            echo '<tr class="active"><td>&nbsp;</td><td colspan="2"><p class="cr_auto_update">';
          echo sprintf( wp_kses( __( 'The plugin is not registered. Automatic updating is disabled. Please purchase a license for it from <a href="%s" target="_blank">here</a> and register  the plugin from the \'Main Settings\' menu using your purchase code. <a href="%s" target="_blank">How I find my purchase code?', 'ucomment-wordpress-blog-auto-commenter'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url( 'https://1.envato.market/c/1264868/275988/4415?u=' . urlencode($plugin_url)), esc_url('//www.youtube.com/watch?v=NElJ5t_Wd48') );     
          echo '</a></p> </td></tr>';
        }, 10, 3 );
        add_action('admin_enqueue_scripts', 'ucomments_admin_enqueue_all');
        add_filter("plugin_action_links_$plugin", 'ucomments_add_activation_link');
    }
}
function ucomments_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'ucomments-plugin-reg-style', false );
    wp_enqueue_style( 'ucomments-plugin-reg-style' );
    wp_add_inline_style( 'ucomments-plugin-reg-style', $reg_css_code );
}
add_action('add_meta_boxes', 'ucomments_add_meta_box');
function ucomments_add_meta_box()
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['ucomments_enabled']) && $ucomments_Main_Settings['ucomments_enabled'] === 'on') {
        foreach ( get_post_types( '', 'names' ) as $post_type ) {
           add_meta_box('ucomments_meta_box_function_add', esc_html__('uComment Information', 'ucomment-wordpress-blog-auto-commenter'), 'ucomments_meta_box_function', $post_type, 'advanced', 'default', array('__back_compat_meta_box' => true));
        }
    }
}
add_action('admin_enqueue_scripts', 'ucomments_admin_do_post');
function ucomments_admin_do_post()
{
    wp_enqueue_script('ucomments-poster-script', plugins_url('scripts/postnow.js', __FILE__), array('jquery'), false, true);
}
function ucomments_meta_box_function($post)
{
    wp_suspend_cache_addition(true);
    if(strstr($_SERVER['REQUEST_URI'], 'wp-admin/post-new.php')) 
    {
    }
    else
    {
        $ech = '<div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle"><div class="bws_hidden_help_text cr_min_260px">' . esc_html__("WordPress comments will be submitted respecting the configurations you made in the \'Comments to WordPress\' plugin menu section.", 'ucomment-wordpress-blog-auto-commenter') . '</div></div>&nbsp;<span id="ucomments_span">Manually submit WordPress comment based on this post: </span><br/><br/><form id="ucomments_form"><input class="button button-primary button-large" type="button" name="ucomments_submit_post" id="ucomments_submit_post" value="' . esc_html__('Post To WordPress Comment Now!', 'ucomment-wordpress-blog-auto-commenter') . '" onclick="ucomments_post_now(' . $post->ID . ');"/></form><br/><hr/>';
        echo $ech;
    }
    wp_suspend_cache_addition(false);
}
add_action( 'enqueue_block_editor_assets', 'ucomments_enqueue_block_editor_assets' );
function ucomments_enqueue_block_editor_assets() {
    wp_register_style('ucomments-browser-style', plugins_url('styles/ucomment-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('ucomments-browser-style');
	$block_js_list   = 'scripts/sidebar.js';
	wp_enqueue_script(
		'ucomments-sidebar-js', 
        plugins_url( $block_js_list, __FILE__ ), 
        array( 'wp-plugins', 'wp-edit-post', 'wp-element', 'wp-data' ),
        '1.0.0'
	);
}
function ucomments_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=ucomments_admin_settings">' . esc_html__('Activate Plugin License', 'ucomment-wordpress-blog-auto-commenter') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_action('admin_menu', 'ucomments_register_my_custom_menu_page');
add_action('network_admin_menu', 'ucomments_register_my_custom_menu_page');
function ucomments_register_my_custom_menu_page()
{
    add_menu_page('uComment WP Comment Bot', 'uComment WP Comment Bot', 'manage_options', 'ucomments_admin_settings', 'ucomments_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main = add_submenu_page('ucomments_admin_settings', esc_html__("Main Settings", 'ucomment-wordpress-blog-auto-commenter'), esc_html__("Main Settings", 'ucomment-wordpress-blog-auto-commenter'), 'manage_options', 'ucomments_admin_settings');
    add_action( 'load-' . $main, 'ucomments_load_all_admin_js' );
    add_action( 'load-' . $main, 'ucomments_load_main_admin_js' );
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['ucomments_enabled']) && $ucomments_Main_Settings['ucomments_enabled'] == 'on') {
        $comm = add_submenu_page('ucomments_admin_settings', esc_html__('Comments to Blogs', 'ucomment-wordpress-blog-auto-commenter'), esc_html__('Comments to Blogs', 'ucomment-wordpress-blog-auto-commenter'), 'manage_options', 'ucomments_youtube_panel', 'ucomments_youtube_panel');
        add_action( 'load-' . $comm, 'ucomments_load_post_admin_js' );
        add_action( 'load-' . $comm, 'ucomments_load_all_admin_js' );
        $logs = add_submenu_page('ucomments_admin_settings', esc_html__("Activity & Logging", 'ucomment-wordpress-blog-auto-commenter'), esc_html__("Activity & Logging", 'ucomment-wordpress-blog-auto-commenter'), 'manage_options', 'ucomments_logs', 'ucomments_logs');
        add_action( 'load-' . $logs, 'ucomments_load_all_admin_js' );
    }
}
function ucomments_load_post_admin_js(){
    add_action('admin_enqueue_scripts', 'ucomments_admin_load_post_files');
}

function ucomments_admin_load_post_files()
{
    wp_register_script('ucomments-submitter-script', plugins_url('scripts/poster.js', __FILE__), false, '1.0.0');
    wp_enqueue_script('ucomments-submitter-script');
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if(!isset($ucomments_Comment_Settings['best_user']))
    {
        $best_user = '';
    }
    else
    {
        $best_user = $ucomments_Comment_Settings['best_user'];
    }
    if(!isset($ucomments_Comment_Settings['best_password']))
    {
        $best_password = '';
    }
    else
    {
        $best_password = $ucomments_Comment_Settings['best_password'];
    }
    $header_main_settings = array(
        'best_user' => $best_user,
        'best_password' => $best_password
    );
    wp_localize_script('ucomments-submitter-script', 'mycustommainsettings', $header_main_settings);
}
function ucomments_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'ucomments_enqueue_main_admin_js');
}

function ucomments_enqueue_main_admin_js(){
    wp_enqueue_script('ucomment-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
}
function ucomments_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'ucomments_admin_load_files');
}
function ucomments__add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'ucomments_add_support_link');
function ucomments_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'ucomment-wordpress-blog-auto-commenter') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'ucomments_add_settings_link');
add_filter("plugin_action_links_$plugin", 'ucomments__add_rating_link');
function ucomments_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=ucomments_admin_settings">' . esc_html__('Settings', 'ucomment-wordpress-blog-auto-commenter') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function ucomments_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/ucomments_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/ucomments_info.log');
    }
}

register_deactivation_hook(__FILE__, 'ucomments_my_deactivation');
function ucomments_my_deactivation()
{
    wp_clear_scheduled_hook('ucommentactionclear');
}
add_action('ucommentactionclear', 'ucomments_auto_clear_log');


function ucomments_builtin_spin_text($title, $content)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . ' ' . $titleSeparator . ' ' . $content;
    $text                   = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        $file=file(dirname(__FILE__)  .'/res/synonyms.dat');
		foreach($file as $line){
			$synonyms=explode('|',$line);
			foreach($synonyms as $word){
				if(trim($word) != ''){
                    $word=str_replace('/','\/',$word);
					if(preg_match('/\b'. $word .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$word.'\b/u', trim($synonyms[$rand]), $text);
					}
                    $uword=ucfirst($word);
					if(preg_match('/\b'. $uword .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$uword.'\b/u', ucfirst(trim($synonyms[$rand])), $text);
					}
				}
			}
		}
        $translated = $text;
    }
    catch (Exception $e) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Exception thrown in spinText ' . $e->getMessage());
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}

function ucomments_cron_schedule()
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['ucomments_enabled']) && $ucomments_Main_Settings['ucomments_enabled'] === 'on') {
        
        if (isset($ucomments_Main_Settings['enable_logging']) && $ucomments_Main_Settings['enable_logging'] === 'on' && isset($ucomments_Main_Settings['auto_clear_logs']) && $ucomments_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('ucommentactionclear')) {
                $rez = wp_schedule_event(time(), $ucomments_Main_Settings['auto_clear_logs'], 'ucommentactionclear');
                if ($rez === FALSE) {
                    ucomments_log_to_file('[Scheduler] Failed to schedule ucommentactionclear to ' . $ucomments_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('ucomments_schedule_time', $ucomments_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('ucomments_schedule_time')) {
                    wp_clear_scheduled_hook('ucommentactionclear');
                    $rez = wp_schedule_event(time(), $ucomments_Main_Settings['auto_clear_logs'], 'ucommentactionclear');
                    add_option('ucomments_schedule_time', $ucomments_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        ucomments_log_to_file('[Scheduler] Failed to schedule ucommentactionclear to ' . $ucomments_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('ucomments_schedule_time');
                    if ($the_time != $ucomments_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('ucommentactionclear');
                        delete_option('ucomments_schedule_time');
                        $rez = wp_schedule_event(time(), $ucomments_Main_Settings['auto_clear_logs'], 'ucommentactionclear');
                        add_option('ucomments_schedule_time', $ucomments_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            ucomments_log_to_file('[Scheduler] Failed to schedule ucommentactionclear to ' . $ucomments_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('ucommentactionclear')) {
                delete_option('ucomments_schedule_time');
            } else {
                wp_clear_scheduled_hook('ucommentactionclear');
                delete_option('ucomments_schedule_time');
            }
        }
    } else {
        if (!wp_next_scheduled('ucommentactionclear')) {
            delete_option('ucomments_schedule_time');
        } else {
            wp_clear_scheduled_hook('ucommentactionclear');
            delete_option('ucomments_schedule_time');
        }
    }
}

function ucomments_log_to_file($str)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['enable_logging']) && $ucomments_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/ucomments_info.log');
    }
}

function ucomments_clearFromList($param)
{
    $GLOBALS['wp_object_cache']->delete('ucomments_running_list', 'options');
    $running = get_option('ucomments_running_list');
    $key     = array_search($param, $running);
    if ($key !== FALSE) {
        unset($running[$key]);
        update_option('ucomments_running_list', $running);
    } 
}

function ucomments_isCurl(){
    return function_exists('curl_version');
}

function ucomments_get_web_page($url)
{
    $content = false;
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (!isset($ucomments_Main_Settings['proxy_url']) || $ucomments_Main_Settings['proxy_url'] == '') {
        $args = array(
           'timeout'     => 10,
           'redirection' => 10,
           'user-agent'  => ucomments_get_random_user_agent(),
           'blocking'    => true,
           'headers'     => array(),
           'cookies'     => array(),
           'body'        => null,
           'compress'    => false,
           'decompress'  => true,
           'sslverify'   => false,
           'stream'      => false,
           'filename'    => null
        );
        $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
        $response_code       = wp_remote_retrieve_response_code( $ret_data );
        $response_message    = wp_remote_retrieve_response_message( $ret_data );        
        if ( 200 != $response_code ) {
        } else {
            $content = wp_remote_retrieve_body( $ret_data );
        }
    }
    if($content === false)
    {
        if(ucomments_isCurl() && filter_var($url, FILTER_VALIDATE_URL))
        {
            $user_agent = ucomments_get_random_user_agent();
            $options    = array(
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_POST => false,
                CURLOPT_USERAGENT => $user_agent,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HEADER => false,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => 10,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_REFERER => get_site_url(),
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0
            );
            $ch         = curl_init($url);
            if ($ch === FALSE) {
                return FALSE;
            }
            if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
                if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
                    curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
                }
            }
            curl_setopt_array($ch, $options);
            $content = curl_exec($ch);
            curl_close($ch);
        }
        else
        {
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                return $wp_filesystem->get_contents($url);
            }
        }
    }
    return $content;
}

function ucomments_isSecure() {
  return
    (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
    || $_SERVER['SERVER_PORT'] == 443;
}

$ucomments_fatal = false;
function ucomments_clear_flag_at_shutdown($param)
{
    $error = error_get_last();
    if ($error !== null && $error['type'] === E_ERROR && $GLOBALS['ucomments_fatal'] === false) {
        $GLOBALS['ucomments_fatal'] = true;
        $running = array();
        update_option('ucomments_running_list', $running);
        ucomments_log_to_file('[FATAL] Exit error: ' . $error['message'] . ', file: ' . $error['file'] . ', line: ' . $error['line'] . ' - rule ID: ' . $param . '!');
        ucomments_clearFromList($param);
    }
    else
    {
        ucomments_clearFromList($param);
    }
}

add_action('wp_ajax_ucomments_post_now', 'ucomments_ucomments_submit_post_callback');
function ucomments_ucomments_submit_post_callback()
{
    $run_id = $_POST['id'];
    $wp_post = get_post($run_id);
    if($wp_post != null)
    {
        ucomments_do_post($wp_post, true);
    }
    die();
}

register_activation_hook(__FILE__, 'ucomments_activation_callback');
function ucomments_activation_callback($defaults = FALSE)
{
    if (!get_option('ucomments_Main_Settings') || $defaults === TRUE) {
        $ucomments_Main_Settings = array(
            'ucomments_enabled' => 'on',
            'translate' => 'disabled',
            'translate_source' => 'disabled',
            'ucomments_enable_caching' => '',
            'ucomments_force_feeds' => '',
            'ucomments_custom_simplepie' => 'on',
            'clear_user_agent' => '',
            'google_trans_auth' => '',
            'sentence_list' => 'This is one %adjective %noun %sentence_ending
This is another %adjective %noun %sentence_ending
I %love_it %nouns , because they are %adjective %sentence_ending
My %family says this plugin is %adjective %sentence_ending
These %nouns are %adjective %sentence_ending',
            'sentence_list2' => 'Meet this %adjective %noun %sentence_ending
This is the %adjective %noun ever %sentence_ending
I %love_it %nouns , because they are the %adjective %sentence_ending
My %family says this plugin is very %adjective %sentence_ending
These %nouns are quite %adjective %sentence_ending',
            'variable_list' => 'adjective_very => %adjective;very %adjective;

adjective => clever;interesting;smart;huge;astonishing;unbelievable;nice;adorable;beautiful;elegant;fancy;glamorous;magnificent;helpful;awesome

noun_with_adjective => %noun;%adjective %noun

noun => plugin;WordPress plugin;item;ingredient;component;constituent;module;add-on;plug-in;addon;extension

nouns => plugins;WordPress plugins;items;ingredients;components;constituents;modules;add-ons;plug-ins;addons;extensions

love_it => love;adore;like;be mad for;be wild about;be nuts about;be crazy about

family => %adjective %family_members;%family_members

family_members => grandpa;brother;sister;mom;dad;grandma

sentence_ending => .;!;!!',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'remove_flood_prot' => '',
            'enable_detailed_logging' => 'on',
            'rule_timeout' => '3600',
			'proxy_auth' => '',
			'proxy_url' => ''
        );
        if ($defaults === FALSE) {
            add_option('ucomments_Main_Settings', $ucomments_Main_Settings);
        } else {
            update_option('ucomments_Main_Settings', $ucomments_Main_Settings);
        }
    }
    if (!get_option('ucomments_Comment_Settings') || $defaults === TRUE) {
        $ucomments_Comment_Settings = array(
            'run_background' => '',
            'youtube_format' => '%%post_title%%',
            'post_posts' => '',
            'post_pages' => '',
            'select_blog_method' => 'random',
            'blog_list' => '',
            'links_hide_google2' => '',
            'apiKey' => '',
            'post_custom' => '',
            'disabled_categories' => array(),
            'disable_tags' => '',
            'delay_post' => '',
            'comment_timeout' => '500',
            'max_published' => '1',
            'max_failed_published' => '10',
            'url_list' => '',
            'email_list' => '',
            'user_list' => '',
            'max_day' => '',
            'select_method' => 'random',
            'post_select_method' => 'random',
            'channel_id' => '',
            'rule_keywords' => '',
            'max_keywords' => '2',
            'search_method' => 'title',
            'max' => '5',
            'ids' => '',
            'post_channel_id' => '',
            'event_type' => 'uploaded',
            'coord' => '',
            'radius' => '',
            'result_type' => 'any',
            'safe_search' => 'moderate',
            'region_code' => 'any',
            'video_caption' => 'any',
            'video_definition' => 'any',
            'video_dimension' => 'any',
            'video_duration' => 'any',
            'video_license' => 'any',
            'video_type' => 'any',
            'video_syndication' => 'any',
            'search_order' => 'relevance',
            'video_embeddable' => 'any',
            'video_category' => '0',
            'required_words' => '',
            'banned_words' => '',
            'best_password' => '',
            'best_user' => '',
            'spin_text' => 'disabled'
        );
        if ($defaults === FALSE) {
            add_option('ucomments_Comment_Settings', $ucomments_Comment_Settings);
        } else {
            update_option('ucomments_Comment_Settings', $ucomments_Comment_Settings);
        }
    }
}

function ucomments_post_url_handle($href)
{
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (isset($ucomments_Comment_Settings['links_hide_google2']) && $ucomments_Comment_Settings['links_hide_google2'] == 'on') {
        $cloak_urls = true;
    } else {
        $cloak_urls = false;
    }
    if (isset($ucomments_Comment_Settings['apiKey'])) {
        $apiKey = trim($ucomments_Comment_Settings['apiKey']);
    } else {
        $apiKey = '';
    }
    if ($cloak_urls == true && $apiKey != '') {
        $ucomments_short_group = get_option('ucomments_short_group', false);
        $found = false;
        if($ucomments_short_group !== false)
        {
            $ucomments_short_group = explode('#', $ucomments_short_group);
            if(isset($ucomments_short_group[1]) && $ucomments_short_group[0] == $apiKey)
            {
                $ucomments_short_group = $ucomments_short_group[1];
                $found = true;
            }
        }
        if($found == false)
        {
            $url = 'https://api-ssl.Bitly.com/v4/groups';
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $headers = [
                'Authorization: Bearer ' . $apiKey,
                'Accept: application/json',
                'Host: api-ssl.Bitly.com'
            ];
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            $serverOutput = json_decode(curl_exec($ch), true);
            curl_close($ch);
            if(isset($serverOutput['groups'][0]['guid']))
            {
                $ucomments_short_group = $serverOutput['groups'][0]['guid'];
                update_option('ucomments_short_group', false);
                $found = true;
            }
        }
        if($found == false)
        {
            return $href;
        }
        $url = 'https://api-ssl.Bitly.com/v4/shorten';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        $headers = [
            'Authorization: Bearer ' . $apiKey,
            'Content-Type: application/json',
            'Host: api-ssl.Bitly.com'
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_POST, true);
        $fdata = "";
        $data['long_url'] = trim($href);
        $data['group_guid'] = $ucomments_short_group;
        $fdata = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
        $serverOutput = json_decode(curl_exec($ch), true);
        curl_close($ch);
        if (!isset($serverOutput['link']) || $serverOutput['link'] == '') {
            return $href;
        } else {
            return esc_url($serverOutput['link']);
        }  
    } else {
        return $href;
    }
}


function ucomments_get_mime ($filename) {
    $mime_types = array(
        'txt' => 'text/plain',
        'htm' => 'text/html',
        'html' => 'text/html',
        'php' => 'text/html',
        'css' => 'text/css',
        'js' => 'application/javascript',
        'json' => 'application/json',
        'xml' => 'application/xml',
        'swf' => 'application/x-shockwave-flash',
        'flv' => 'video/x-flv',
        'png' => 'image/png',
        'jpe' => 'image/jpeg',
        'jpeg' => 'image/jpeg',
        'jpg' => 'image/jpeg',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'ico' => 'image/vnd.microsoft.icon',
        'tiff' => 'image/tiff',
        'mts' => 'video/mp2t',
        'tif' => 'image/tiff',
        'svg' => 'image/svg+xml',
        'svgz' => 'image/svg+xml',
        'zip' => 'application/zip',
        'rar' => 'application/x-rar-compressed',
        'exe' => 'application/x-msdownload',
        'msi' => 'application/x-msdownload',
        'cab' => 'application/vnd.ms-cab-compressed',
        'mp3' => 'audio/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'wmv' => 'video/x-ms-wmv',
        'mp4' => 'video/mp4',
        'm4p' => 'video/m4p',
        'm4v' => 'video/m4v',
        'mpg' => 'video/mpg',
        'mp2' => 'video/mp2',
        'mpe' => 'video/mpe',
        'mpv' => 'video/mpv',
        'm2v' => 'video/m2v',
        'm4v' => 'video/m4v',
        '3g2' => 'video/3g2',
        '3gpp' => 'video/3gpp',
        'f4v' => 'video/f4v',
        'f4p' => 'video/f4p',
        'f4a' => 'video/f4a',
        'f4b' => 'video/f4b',
        '3gp' => 'video/3gp',
        'avi' => 'video/x-msvideo',
        'mpeg' => 'video/mpeg',
        'mpegps' => 'video/mpeg',
        'webm' => 'video/webm',
        'mpeg4' => 'video/mp4',
        'mkv' => 'video/mkv',
        'pdf' => 'application/pdf',
        'psd' => 'image/vnd.adobe.photoshop',
        'ai' => 'application/postscript',
        'eps' => 'application/postscript',
        'ps' => 'application/postscript',
        'doc' => 'application/msword',
        'rtf' => 'application/rtf',
        'xls' => 'application/vnd.ms-excel',
        'ppt' => 'application/vnd.ms-powerpoint',
        'docx' => 'application/msword',
        'xlsx' => 'application/vnd.ms-excel',
        'pptx' => 'application/vnd.ms-powerpoint',
        'odt' => 'application/vnd.oasis.opendocument.text',
        'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
    );
    $ext = array_values(array_slice(explode('.', $filename), -1));$ext = $ext[0];

    if(stristr($filename, 'dailymotion.com'))
    {
        return 'application/octet-stream';
    }
    if (function_exists('mime_content_type') && $filename != '') {
        error_reporting(0);
        $mimetype = mime_content_type($filename);
        error_reporting(E_ALL);
        if($mimetype == '')
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;
    }
    elseif (function_exists('finfo_open')) {
        $finfo = finfo_open(FILEINFO_MIME);
        $mimetype = finfo_file($finfo, $filename);
        finfo_close($finfo);
        if($mimetype === false)
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;

    } elseif (array_key_exists($ext, $mime_types)) {
        return $mime_types[$ext];
    } else {
        return 'application/octet-stream';
    }
}

function ucomments_getUrls($string) {
        $regex = '/https?\:\/\/[^\"\' \n\s]+/i';
        preg_match_all($regex, $string, $matches);
        return ($matches[0]);
}

add_action('ucomments_new_post_cron', 'ucomments_do_post', 10, 1);
add_action('transition_post_status', 'ucomments_new_post', 10, 3);

function ucomments_new_post($new_status, $old_status, $post)
{
    if ('publish' !== $new_status or 'publish' === $old_status)
    {
        return;
    }
    else
    {
        if($old_status == 'auto-draft' && $new_status == 'publish' && !has_post_thumbnail($post->ID) && ((function_exists('has_blocks') && has_blocks($post)) || ($post->post_content == '' && function_exists('has_blocks') && !class_exists('Classic_Editor'))))
        {
            $delay_it_is_gutenberg = true;
        }
        else
        {
            $delay_it_is_gutenberg = false;
        }
    }
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['ucomments_enabled']) && $ucomments_Main_Settings['ucomments_enabled'] == 'on') 
    {
        $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
        if (isset($ucomments_Comment_Settings['delay_post']) && $ucomments_Comment_Settings['delay_post'] != '' && is_numeric($ucomments_Comment_Settings['delay_post'])) {
            if(wp_next_scheduled('ucomments_new_post_cron', array($post)) === false)
            {
                if($delay_it_is_gutenberg && $ucomments_Comment_Settings['delay_post'] < 2)
                {
                    $ucomments_Comment_Settings['delay_post'] = 2;
                }
                wp_schedule_single_event( time() + intval($ucomments_Comment_Settings['delay_post']), 'ucomments_new_post_cron', array($post) );
            }
        }
        else
        {
            if (isset($ucomments_Comment_Settings['run_background']) && $ucomments_Comment_Settings['run_background'] == 'on') {
                if($delay_it_is_gutenberg)
                {
                    if(wp_next_scheduled('ucomments_new_post_cron', array($post)) === false)
                    {
                        wp_schedule_single_event( time() + 2, 'ucomments_new_post_cron', array($post) );
                    }
                }
                else
                {
                    $unique_id = uniqid();
                    update_option('ucomments_do_post_uniqid', $unique_id);
                    $xcron_url = site_url( '?ucomments_do_post_cronjob=1&post_id=' . $post->ID . '&ucomments_do_post_key=' . $unique_id);
                    wp_remote_post( $xcron_url, array( 'timeout' => 1, 'blocking' => false, 'sslverify' => false ) );
                }
            }
            else
            {
                if($delay_it_is_gutenberg)
                {
                    if(wp_next_scheduled('ucomments_new_post_cron', array($post)) === false)
                    {
                        wp_schedule_single_event( time() + 2, 'ucomments_new_post_cron', array($post) );
                    }
                }
                else
                {
                    ucomments_do_post($post);
                }
            }
        }
    }
    
}
add_action('init', 'ucomments_do_post_callback', 0);
function ucomments_do_post_callback()
{
    $secretp_key = get_option('ucomments_do_post_uniqid', false);
    if (isset($_GET['ucomments_do_post_cronjob']) && $_GET['ucomments_do_post_cronjob'] == '1' && isset($_GET['post_id']) && is_numeric($_GET['post_id']) && $_GET['ucomments_do_post_key'] === $secretp_key)
    {
        $post = get_post($_GET['post_id']);
        if($post !== null)
        {
            ucomments_do_post($post);
            exit();
        }
    }
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['remove_flood_prot']) && $ucomments_Main_Settings['remove_flood_prot'] == 'on') 
    {
        add_filter('comment_flood_filter', '__return_false');
    }
}
function ucomments_format_wp_limit( $size ) {
	$value  = substr( $size, -1 );
	$return = substr( $size, 0, -1 );
	$return = (int)$return;
	switch ( strtoupper( $value ) ) {
		case 'P' :
			$return*= 1024;
		case 'T' :
			$return*= 1024;
		case 'G' :
			$return*= 1024;
		case 'M' :
            $return*= 1024;
		case 'K' :
			$return*= 1024;
	}
	return $return;
}  

function ucomments_do_post($post, $manual = false)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if (isset($ucomments_Main_Settings['rule_timeout']) && $ucomments_Main_Settings['rule_timeout'] != '') {
        $timeout = intval($ucomments_Main_Settings['rule_timeout']);
    } else {
        $timeout = 3600;
    }
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    ini_set('user_agent', ucomments_get_random_user_agent());
    ignore_user_abort(true);
    set_time_limit($timeout);
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (isset($ucomments_Comment_Settings['max_published']) && $ucomments_Comment_Settings['max_published'] != '') 
    {
        $maximum_comms = $ucomments_Comment_Settings['max_published'];
    }
    else
    {
        $maximum_comms = 1;
    }
    if (isset($ucomments_Comment_Settings['max_failed_published']) && $ucomments_Comment_Settings['max_failed_published'] != '') 
    {
        $max_failed_published = $ucomments_Comment_Settings['max_failed_published'];
    }
    else
    {
        $max_failed_published = 10;
    }
    $items = array();
    $feed_url_items = array();
    if (isset($ucomments_Main_Settings['ucomments_enabled']) && $ucomments_Main_Settings['ucomments_enabled'] == 'on')
    {
        {
            $my_feed_url = '';
            if (isset($ucomments_Comment_Settings['post_posts'])) {
                if ($ucomments_Comment_Settings['post_posts'] == 'on' && 'post' === $post->post_type) {
                    return;
                }
            }
            if (isset($ucomments_Comment_Settings['post_pages'])) {
                if ($ucomments_Comment_Settings['post_pages'] == 'on' && 'page' === $post->post_type) {
                    return;
                }
            }
            if (isset($ucomments_Comment_Settings['post_custom'])) {
                if ($ucomments_Comment_Settings['post_custom'] == 'on' && 'page' != $post->post_type && 'post' != $post->post_type) {
                    return;
                }
            }
            $meta = get_post_meta($post->ID, "ucomments_published", true);
            if ($meta == 'pub') {
                return;
            }
            if (isset($ucomments_Comment_Settings['banned_words']) && $ucomments_Comment_Settings['banned_words'] != '') {
                $continue    = false;
                $banned_list = explode(',', $ucomments_Comment_Settings['banned_words']);
                foreach ($banned_list as $banned_word) {
                    if (stripos($post->post_content, trim($banned_word)) !== FALSE) {
                        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                            ucomments_log_to_file('Skipping post "' . $post->post_title . '", because it\'s content contains banned word: ' . $banned_word);
                        }
                        $continue = true;
                        break;
                    }
                    if (stripos($post->post_title, trim($banned_word)) !== FALSE) {
                        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                            ucomments_log_to_file('Skipping post "' . $post->post_title . '", because it\'s title contains banned word: ' . $banned_word);
                        }
                        $continue = true;
                        break;
                    }
                }
                if ($continue === true) {
                    return;
                }
            }
            if (isset($ucomments_Comment_Settings['required_words']) && $ucomments_Comment_Settings['required_words'] != '') {
                $continue      = false;
                $required_list = explode(',', $ucomments_Comment_Settings['required_words']);
                foreach ($required_list as $required_word) {
                    if (stripos($post->post_content, trim($required_word)) === FALSE) {
                        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                            ucomments_log_to_file('Skipping post "' . $post->post_title . '", because it\'s content doesn\'t contain required word: ' . $required_word);
                        }
                        $continue = true;
                        break;
                    }
                    if (stripos($post->post_title, trim($required_word)) === FALSE) {
                        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                            ucomments_log_to_file('Skipping post "' . $post->post_title . '", because it\'s title doesn\'t contain required word: ' . $required_word);
                        }
                        $continue = true;
                        break;
                    }
                }
                if ($continue === true) {
                    return;
                }
            }
            $post_cats        = get_post_meta($post->ID, 'ucomments_post_cats', true);
            if($post_cats == '')
            {
                $cats = wp_get_post_categories($post->ID);
                $post_categories = array();
                foreach($cats as $c){
                    $cat = get_category( $c );
                    $post_categories[] = $cat->name;
                }
                $post_cats = implode(',', $post_categories);
            }
            else
            {
                $post_categories  = explode(',', $post_cats);
            }
            if(count($post_categories) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_cat' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_categories[] = $term->slug;
                    }
                    $post_cats = implode(',', $post_categories);
                }
                
            }
            foreach($post_categories as $pc)
            {
                if (isset($ucomments_Comment_Settings['disabled_categories']) && !empty($ucomments_Comment_Settings['disabled_categories'])) {
                    foreach($ucomments_Comment_Settings['disabled_categories'] as $disabled_cat)
                    {
                        if(trim($pc) == get_cat_name($disabled_cat))
                        {
                            return;
                        }
                    }
                }
            }
            $post_tagz = get_post_meta($post->ID, 'ucomments_post_tags', true);
            if($post_tagz == '')
            {
                $tags = wp_get_post_tags($post->ID);
                $post_tags = array();
                foreach($tags as $t){
                    $post_tags[] = $t->name;
                }
                $post_tagz = implode(',', $post_tags);
            }
            else
            {
                $post_tags = explode(',', $post_tagz);
            }
            if(count($post_tags) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_tag' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_tags[] = $term->slug;
                    }
                    $post_tagz = implode(',', $post_tags);
                }
                
            }
            foreach($post_tags as $pt)
            {
                if (isset($ucomments_Comment_Settings['disable_tags']) && $ucomments_Comment_Settings['disable_tags'] != '') {
                    
                    $disable_tags = explode(",", $ucomments_Comment_Settings['disable_tags']);
                    foreach($disable_tags as $disabled_tag)
                    {
                        if(trim($pt) == trim($disabled_tag))
                        {
                            return;
                        }
                    }
                }
            }
            if (isset($ucomments_Comment_Settings['ucomments_custom_simplepie']) && $ucomments_Comment_Settings['ucomments_custom_simplepie'] == 'on') {
                try
                {
                    if(!class_exists('SimplePie_Autoloader', false))
                    {
                        require_once(dirname(__FILE__) . "/res/simplepie/autoloader.php");
                    }
                }
                catch(Exception $e) 
                {
                    ucomments_log_to_file('Exception thrown in SimplePie autoloader: ' . $e->getMessage());
                    return;
                }
            }
            else
            {
                if ( ! class_exists( 'SimplePie', false ) ) {
                    require_once( ABSPATH . WPINC . '/class-simplepie.php' );
                }
                include_once (ABSPATH . WPINC . '/feed.php');
            }
            if (!isset($ucomments_Comment_Settings['blog_list']) && $ucomments_Comment_Settings['blog_list'] == '')
            {
                return;
            }
            else
            {
                $blog_urls = preg_split('/\r\n|\r|\n/', trim($ucomments_Comment_Settings['blog_list']));
                if (isset($ucomments_Comment_Settings['post_select_method']) && $ucomments_Comment_Settings['post_select_method'] == 'exhaust')
                {
                    while(count($blog_urls) > 0 && count($items) < $maximum_comms)
                    {
                        if (isset($ucomments_Comment_Settings['select_blog_method']) && $ucomments_Comment_Settings['select_blog_method'] == 'random')
                        {
                            $my_contor = array_rand($blog_urls);
                        }
                        else
                        {
                            $my_contor = 0;
                        }
                        $my_feed_url = trim($blog_urls[$my_contor]);
                        if($my_feed_url == '')
                        {
                            unset($blog_urls[$my_contor]);
                            continue;
                        }
                        unset($blog_urls[$my_contor]);
                        if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                            $feed = new SimplePie();
                            if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                                $prx_arr = array();
                                $prx = explode(',', $ucomments_Main_Settings['proxy_url']);
                                $randomness = array_rand($prx);
                                $prx_arr[CURLOPT_PROXY] = trim($prx[$randomness]);
                                if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') 
                                {
                                    $prx_auth = explode(',', $ucomments_Main_Settings['proxy_auth']);
                                    if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                                    {
                                        $prx_arr[CURLOPT_PROXYUSERPWD] = trim($prx_auth[$randomness]);
                                    }
                                }
                                if(method_exists($feed, 'set_curl_options'))
                                {
                                    $feed->set_curl_options($prx_arr);
                                }
                            }
                            if ((isset($ucomments_Main_Settings['ucomments_force_feeds']) && $ucomments_Main_Settings['ucomments_force_feeds'] == 'on') || (strpos($my_feed_url, 'feeds.bbci.co.uk') !== false)) {
                                $feed->force_feed(true);
                            }
                            if (isset($ucomments_Main_Settings['clear_user_agent']) && $ucomments_Main_Settings['clear_user_agent'] == 'on') {
                                $coptions = array();
                                $coptions['CURLOPT_USERAGENT'] = ucomments_get_random_user_agent();
                                $coptions['CURLOPT_HTTP_VERSION'] = "CURL_HTTP_VERSION_1_0";
                                if(method_exists($feed, 'set_curl_options'))
                                {
                                    $feed->set_curl_options($coptions);
                                }
                            }
                            $feed->set_feed_url($my_feed_url);
                            if (isset($ucomments_Main_Settings['ucomments_enable_caching']) && $ucomments_Main_Settings['ucomments_enable_caching'] == 'on') {
                                $feed->enable_cache(true);
                                $feed->set_cache_location(dirname(__FILE__) . "/res/cache");
                            }
                            else
                            {
                                $feed->enable_cache(false);
                            }
                            $feed->init();
                            $feed->handle_content_type();
                            if ($feed->error()) {
                                ucomments_log_to_file('Error in parsing RSS feed (custom method): ' . $feed->error() . ' for ' . $my_feed_url . '!');
                                continue;
                            }
                        }
                        else
                        {
                            $feed = fetch_feed ( $my_feed_url );
                            if (is_wp_error ( $feed )){
                                ucomments_log_to_file('Error in parsing RSS feed (built-in method): ' . $feed->get_error_message() . ' for ' . $my_feed_url . '!');
                                continue;
                            }
                        }
                        $blog_url = $feed->get_link(0);
                        $feed_items = $feed->get_items();
                        $add_me_links = array();
                        foreach($feed_items as $furl)
                        {
                            $feed_url_items[] = $blog_url;
                            $add_me_links[] = $furl->get_permalink();
                        }
                        
                        $items = array_merge($items, $add_me_links);
                        if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                            $feed->__destruct();
                        }
                        $feed = null;
                        unset($feed);
                    }
                    $items = array_filter($items);
                }
                elseif (isset($ucomments_Comment_Settings['post_select_method']) && $ucomments_Comment_Settings['post_select_method'] == 'random') 
                {
                    while(count($blog_urls) > 0 && count($items) < $maximum_comms)
                    {
                        if (isset($ucomments_Comment_Settings['select_blog_method']) && $ucomments_Comment_Settings['select_blog_method'] == 'random')
                        {
                            $my_contor = array_rand($blog_urls);
                        }
                        else
                        {
                            $my_contor = 0;
                        }
                        $my_feed_url = trim($blog_urls[$my_contor]);
                        if($my_feed_url == '')
                        {
                            unset($blog_urls[$my_contor]);
                            continue;
                        }
                        unset($blog_urls[$my_contor]);
                        if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                            $feed = new SimplePie();
                            if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                                $prx_arr = array();
                                $prx = explode(',', $ucomments_Main_Settings['proxy_url']);
                                $randomness = array_rand($prx);
                                $prx_arr[CURLOPT_PROXY] = trim($prx[$randomness]);
                                if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') 
                                {
                                    $prx_auth = explode(',', $ucomments_Main_Settings['proxy_auth']);
                                    if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                                    {
                                        $prx_arr[CURLOPT_PROXYUSERPWD] = trim($prx_auth[$randomness]);
                                    }
                                }
                                if(method_exists($feed, 'set_curl_options'))
                                {
                                    $feed->set_curl_options($prx_arr);
                                }
                            }
                            if ((isset($ucomments_Main_Settings['ucomments_force_feeds']) && $ucomments_Main_Settings['ucomments_force_feeds'] == 'on') || (strpos($my_feed_url, 'feeds.bbci.co.uk') !== false)) {
                                $feed->force_feed(true);
                            }
                            if (isset($ucomments_Main_Settings['clear_user_agent']) && $ucomments_Main_Settings['clear_user_agent'] == 'on') {
                                $coptions = array();
                                $coptions['CURLOPT_USERAGENT'] = ucomments_get_random_user_agent();
                                $coptions['CURLOPT_HTTP_VERSION'] = "CURL_HTTP_VERSION_1_0";
                                if(method_exists($feed, 'set_curl_options'))
                                {
                                    $feed->set_curl_options($coptions);
                                }
                            }
                            $feed->set_feed_url($my_feed_url);
                            if (isset($ucomments_Main_Settings['ucomments_enable_caching']) && $ucomments_Main_Settings['ucomments_enable_caching'] == 'on') {
                                $feed->enable_cache(true);
                                $feed->set_cache_location(dirname(__FILE__) . "/res/cache");
                            }
                            else
                            {
                                $feed->enable_cache(false);
                            }
                            $feed->init();
                            $feed->handle_content_type();
                            if ($feed->error()) {
                                ucomments_log_to_file('Error in parsing RSS feed (custom method): ' . $feed->error() . ' for ' . $my_feed_url . '!');
                                continue;
                            }
                        }
                        else
                        {
                            $feed = fetch_feed ( $my_feed_url );
                            if (is_wp_error ( $feed )){
                                ucomments_log_to_file('Error in parsing RSS feed (built-in method): ' . $feed->get_error_message() . ' for ' . $my_feed_url . '!');
                                continue;
                            }
                        }
                        $blog_url = $feed->get_link(0);
                        $feed_items = $feed->get_items();
                        $add_me_links = array();
                        $random_count = rand(0, count($feed_items));
                        $addz = 0;
                        foreach($feed_items as $furl)
                        {
                            if($addz >= $random_count)
                            {
                                break;
                            }
                            $addz++;
                            $feed_url_items[] = $blog_url;
                            $add_me_links[] = $furl->get_permalink();
                        }
                        
                        $items = array_merge($items, $add_me_links);
                        if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                            $feed->__destruct();
                        }
                        $feed = null;
                        unset($feed);
                    }
                    $items = array_filter($items);
                }
                else
                {
                    if(count($blog_urls) > 0)
                    {
                        $per_feed = $maximum_comms/count($blog_urls);
                        if($per_feed == 0)
                        {
                            $per_feed = 1;
                        }
                        while(count($blog_urls) > 0 && count($items) < $maximum_comms)
                        {
                            if (isset($ucomments_Comment_Settings['select_blog_method']) && $ucomments_Comment_Settings['select_blog_method'] == 'random')
                            {
                                $my_contor = array_rand($blog_urls);
                            }
                            else
                            {
                                $my_contor = 0;
                            }
                            $my_feed_url = trim($blog_urls[$my_contor]);
                            if($my_feed_url == '')
                            {
                                unset($blog_urls[$my_contor]);
                                continue;
                            }
                            unset($blog_urls[$my_contor]);
                            if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                                $feed = new SimplePie();
                                if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                                    $prx_arr = array();
                                    $prx = explode(',', $ucomments_Main_Settings['proxy_url']);
                                    $randomness = array_rand($prx);
                                    $prx_arr[CURLOPT_PROXY] = trim($prx[$randomness]);
                                    if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') 
                                    {
                                        $prx_auth = explode(',', $ucomments_Main_Settings['proxy_auth']);
                                        if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                                        {
                                            $prx_arr[CURLOPT_PROXYUSERPWD] = trim($prx_auth[$randomness]);
                                        }
                                    }
                                    if(method_exists($feed, 'set_curl_options'))
                                    {
                                        $feed->set_curl_options($prx_arr);
                                    }
                                }
                                if ((isset($ucomments_Main_Settings['ucomments_force_feeds']) && $ucomments_Main_Settings['ucomments_force_feeds'] == 'on') || (strpos($my_feed_url, 'feeds.bbci.co.uk') !== false)) {
                                    $feed->force_feed(true);
                                }
                                if (isset($ucomments_Main_Settings['clear_user_agent']) && $ucomments_Main_Settings['clear_user_agent'] == 'on') {
                                    $coptions = array();
                                    $coptions['CURLOPT_USERAGENT'] = ucomments_get_random_user_agent();
                                    $coptions['CURLOPT_HTTP_VERSION'] = "CURL_HTTP_VERSION_1_0";
                                    if(method_exists($feed, 'set_curl_options'))
                                    {
                                       $feed->set_curl_options($coptions);
                                    }
                                }
                                $feed->set_feed_url($my_feed_url);
                                if (isset($ucomments_Main_Settings['ucomments_enable_caching']) && $ucomments_Main_Settings['ucomments_enable_caching'] == 'on') {
                                    $feed->enable_cache(true);
                                    $feed->set_cache_location(dirname(__FILE__) . "/res/cache");
                                }
                                else
                                {
                                    $feed->enable_cache(false);
                                }
                                $feed->init();
                                $feed->handle_content_type();
                                if ($feed->error()) {
                                    ucomments_log_to_file('Error in parsing RSS feed (custom method): ' . $feed->error() . ' for ' . $my_feed_url . '!');
                                    continue;
                                }
                            }
                            else
                            {
                                $feed = fetch_feed ( $my_feed_url );
                                if (is_wp_error ( $feed )){
                                    ucomments_log_to_file('Error in parsing RSS feed (built-in method): ' . $feed->get_error_message() . ' for ' . $my_feed_url . '!');
                                    continue;
                                }
                            }
                            $blog_url = $feed->get_link(0);
                            $feed_items = $feed->get_items();
                            $add_me_links = array();
                            $addz = 0;
                            foreach($feed_items as $furl)
                            {
                                if($addz >= $per_feed)
                                {
                                    break;
                                }
                                $addz++;
                                $feed_url_items[] = $blog_url;
                                $add_me_links[] = $furl->get_permalink();
                            }
                            
                            $items = array_merge($items, $add_me_links);
                            if (isset($ucomments_Main_Settings['ucomments_custom_simplepie']) && $ucomments_Main_Settings['ucomments_custom_simplepie'] == 'on') {
                                $feed->__destruct();
                            }
                            $feed = null;
                            unset($feed);
                        }
                        $items = array_filter($items);
                    }
                }
            }
            $post_link        = ucomments_post_url_handle(get_permalink($post->ID));
            $post_title       = html_entity_decode($post->post_title);
            $blog_title       = html_entity_decode(get_bloginfo('title'));
            $post_excerpt     = html_entity_decode($post->post_excerpt);
            $post_content     = do_shortcode(html_entity_decode($post->post_content));
            if(function_exists('do_blocks'))
            {
                $post_content     = do_blocks($post_content);
            }
            $post_content = apply_filters( 'the_content', $post_content);
            $post_description = $post_excerpt;
            $author_obj       = get_user_by('id', $post->post_author);
            if(isset($author_obj->user_nicename))
            {
                $user_name        = $author_obj->user_nicename;
            }
            else
            {
                $user_name        = 'Administrator';
            }
            $featured_image   = '';
            wp_suspend_cache_addition(true);
            $metas = get_post_custom($post->ID);
            wp_suspend_cache_addition(false);
            $rez_meta = ucomments_preg_grep_keys('#.+?_featured_ima?ge?#i', $metas);
            if(count($rez_meta) > 0)
            {
                foreach($rez_meta as $rm)
                {
                    if(isset($rm[0]) && filter_var($rm[0], FILTER_VALIDATE_URL))
                    {
                        $featured_image = $rm[0];
                        break;
                    }
                }
            }
            if($featured_image == '')
            {
                $featured_image = ucomments_generate_thumbmail($post->ID);;
            }
            if($featured_image == '')
            {
                $dom     = new DOMDocument();
                $internalErrors = libxml_use_internal_errors(true);
                $dom->loadHTML($post_content);
                    libxml_use_internal_errors($internalErrors);
                $tags      = $dom->getElementsByTagName('img');
                foreach ($tags as $tag) {
                    $temp_get_img = $tag->getAttribute('src');
                    if ($temp_get_img != '') {
                        $temp_get_img = strtok($temp_get_img, '?');
                        $featured_image = rtrim($temp_get_img, '/');
                    }
                }
            }
            $post_added = false;
            
            try
            {
                if (isset($ucomments_Comment_Settings['url_list']) && $ucomments_Comment_Settings['url_list'] != '') {
                    $blog_url_list = preg_split('/\r\n|\r|\n/', trim($ucomments_Comment_Settings['url_list']));
                }
                else
                {
                    $blog_url_list = array('https://www.google.com/');
                }
                if (isset($ucomments_Comment_Settings['user_list']) && $ucomments_Comment_Settings['user_list'] != '') {
                    $blog_user_list = preg_split('/\r\n|\r|\n/', trim($ucomments_Comment_Settings['user_list']));
                }
                else
                {
                    $blog_user_list = array('anonymous');
                }
                if (isset($ucomments_Comment_Settings['email_list']) && $ucomments_Comment_Settings['email_list'] != '') {
                    $blog_email_list = preg_split('/\r\n|\r|\n/', trim($ucomments_Comment_Settings['email_list']));
                }
                else
                {
                    $blog_email_list = array('anonymous@anonymous.com');
                }
                $posted_comms = 0;
                $total_comms = 0;
                $rand_index = 0;
                while(count($items) > 0 && $maximum_comms > $posted_comms && $max_failed_published > $total_comms)
                {
                    $total_comms++;
                    if (isset($ucomments_Comment_Settings['max_day']) && $ucomments_Comment_Settings['max_day'] != '') {
                        $curr_date = get_option('ucomments_date_x', false);
                        $curr_cnt = get_option('ucomments_count_x', false);
                        if($curr_cnt !== false && $curr_date !== false)
                        {
                            if($curr_date == date('Y-m-d'))
                            {
                                $maximum_commsx = $ucomments_Comment_Settings['max_day'];
                                if($curr_cnt >= intval($maximum_commsx))
                                {
                                    break;
                                }
                                $curr_cnt = $curr_cnt + 1;
                                update_option('ucomments_count_x', $curr_cnt);
                            }
                            else
                            {
                                update_option('ucomments_date_x', date('Y-m-d'));
                                update_option('ucomments_count_x', 1);
                            }
                        }
                        else
                        {
                            update_option('ucomments_date_x', date('Y-m-d'));
                            update_option('ucomments_count_x', 1);
                        }
                    }
                    if (isset($ucomments_Comment_Settings['select_method']) && $ucomments_Comment_Settings['select_method'] == 'random') {
                        $rand_index = array_rand($items);
                    }
                    $item = trim($items[$rand_index]);
                    if($item == '')
                    {
                        continue;
                    }
                    $web_page_content = ucomments_get_web_page($item);
                    if ($web_page_content === FALSE) {
                        ucomments_log_to_file('Failed to get web page: ' . $item);
                        continue;
                    }
                    preg_match_all("{name=['\"]?comment_post_ID['\"]?(?:.+?)value=['\"]?(\d+)['\"]?}i", $web_page_content, $post_id_match);
                    
                    if(isset($post_id_match[1][0]))
                    {
                        $my_post_id = $post_id_match[1][0];
                    }
                    else
                    {
                        ucomments_log_to_file('Failed to find pattern in page : ' . $item);
                        continue;
                    }
                    $post_template    = $ucomments_Comment_Settings['youtube_format'];
                    $post_template    = ucomments_replaceYVACPostShortcodes($post_template, $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz);
                    $post_template    = strip_tags($post_template);
                    $post_template    = str_replace('<', '', $post_template);
                    $post_template    = str_replace('>', '', $post_template);
                    $arr              = ucomments_spin_and_translate($post_template, 'hello');
                    $post_template    = $arr[0];
                    if($post_template == '')
                    {
                        ucomments_log_to_file('Comment template cannot be empty! ' . $ucomments_Comment_Settings['youtube_format']);
                        continue;
                    }
                    $my_blog_url = $feed_url_items[$rand_index];
                    unset($feed_url_items[$rand_index]);
                    unset($items[$rand_index]);
                    $postfields = array();
                    $postfields["action"] = "submit";
                    $this_user = $blog_user_list[array_rand($blog_user_list)];
                    $this_user = str_replace('%%random_sentence%%', ucomments_random_sentence_generator(), $this_user);
                    $this_user = str_replace('%%random_sentence2%%', ucomments_random_sentence_generator(false), $this_user);
                    $this_user = str_replace('%%author_name%%', $user_name, $this_user);
                    $postfields["author"] = trim($this_user);
                    $this_email = $blog_email_list[array_rand($blog_email_list)];
                    $this_email = str_replace('%%random_sentence%%', ucomments_random_sentence_generator(), $this_email);
                    $this_email = str_replace('%%random_sentence2%%', ucomments_random_sentence_generator(false), $this_email);
                    $postfields["email"] = trim($this_email);
                    $this_url = $blog_url_list[array_rand($blog_url_list)];
                    $this_url = str_replace('%%random_sentence%%', ucomments_random_sentence_generator(), $this_url);
                    $this_url = str_replace('%%random_sentence2%%', ucomments_random_sentence_generator(false), $this_url);
                    $this_url = str_replace('%%post_link%%', $post_link, $this_url);
                    $postfields["url"] = trim($this_url);
                    $postfields["comment"] = $post_template;
                    $postfields["comment_post_ID"] = $my_post_id;
                    $postfields["comment_parent"] = "0";
                    $url = $my_blog_url . "/wp-comments-post.php";
                    $useragent = ucomments_get_random_user_agent();
                    $referer = 'https://www.google.com'; 
                    $ch = curl_init($url);
                    curl_setopt_array($ch, array(
                      CURLOPT_ENCODING => "",
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 10,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => "POST",
                      
                    ));
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
                    curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
                    curl_setopt($ch, CURLOPT_REFERER, $referer);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    $result = curl_exec($ch);
                    if ($result === FALSE) {
                       if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                            ucomments_log_to_file('Failed to upload comment to blog: ' . curl_error($ch));
                        }
                    }
                    else
                    {
                        if(stristr($result, 'wp-die-message') !== false)
                        {
                            $d = new DOMDocument;
                            $mock = new DOMDocument;
                            $d->loadHTML($result);
                            $body = $d->getElementsByTagName('body')->item(0);
                            foreach ($body->childNodes as $child){
                                $mock->appendChild($mock->importNode($child, true));
                            }
                            ucomments_log_to_file('Failed to submit comment to: ' . $item . ' error response: ' . esc_html($mock->saveHTML()));
                        }
                        else
                        {
                            if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                                ucomments_log_to_file('Successfully uploaded comment to blog post. URL: ' . $item . ' response ' . $result);
                            }
                            $posted_comms++;
                            $post_added = true;
                        }
                    }
                    curl_close($ch);
                    if (isset($ucomments_Comment_Settings['comment_timeout']) && $ucomments_Comment_Settings['comment_timeout'] != '' && is_numeric($ucomments_Comment_Settings['comment_timeout'])) {
                        error_log($ucomments_Comment_Settings['comment_timeout'] * 1000);
                        usleep($ucomments_Comment_Settings['comment_timeout'] * 1000);
                    }
                }
            }
            catch(Exception $e) 
            {
                ucomments_log_to_file('Exception thrown in Youtube posting: ' . $e->getMessage());
                return;
            }
            if ($post_added === TRUE) {
                add_post_meta($post->ID, "ucomments_published", "pub");
            }
        }
    }
}    
           
function ucomments_searchListByKeyword($service, $part, $params) {
    $params = array_filter($params);
    $response = $service->search->listSearch(
        $part,
        $params
    );

    return $response;
}
function ucomments_is_json($string) {
 json_decode($string);
 return (json_last_error() == JSON_ERROR_NONE);
}

function ucomments_preg_grep_keys( $pattern, $input, $flags = 0 )
{
    if(!is_array($input))
    {
        return array();
    }
    $keys = preg_grep( $pattern, array_keys( $input ), $flags );
    $vals = array();
    foreach ( $keys as $key )
    {
        $vals[$key] = $input[$key];
    }
    return $vals;
}
function ucomments_generate_thumbmail( $post_id )
{    
    $post = get_post($post_id);
    $post_parent_id = $post->post_parent === 0 ? $post->ID : $post->post_parent;
    if ( has_post_thumbnail($post_parent_id) )
    {
        if ($id_attachment = get_post_thumbnail_id($post_parent_id)) {
            $the_image  = wp_get_attachment_url($id_attachment, false);
            return $the_image;
        }
    }
    $attachments = array_values(get_children(array(
        'post_parent' => $post_parent_id, 
        'post_status' => 'inherit', 
        'post_type' => 'attachment', 
        'post_mime_type' => 'image', 
        'order' => 'ASC', 
        'orderby' => 'menu_order ID') 
    ));
    if( sizeof($attachments) > 0 ) {
        $the_image  = wp_get_attachment_url($attachments[0]->ID, false);
        return $the_image;
    }
    $media = get_attached_media('image', $post_id);
    if( sizeof($media) > 0 ) {
        $the_image  = wp_get_attachment_url($media[0]->ID, false);
        return $the_image;
    }
    $image_url = ucomments_extractThumbnail($post->post_content);
    return $image_url;
}
function ucomments_extractThumbnail($content) {
    $att = ucomments_getUrls($content);
    if(count($att) > 0)
    {
        foreach($att as $link)
        {
            $mime = ucomments_get_mime($link);
            if(stristr($mime, "image/") !== FALSE){
                return $link;
            }
        }
    }
    else
    {
        return '';
    }
    return '';
}

function ucomments_replaceSynergyShortcodes($the_content)
{
    $regex = '#%%([a-z0-9]+?)_(\d+?)_(\d+?)%%#';
    $rezz = preg_match_all($regex, $the_content, $matches);
    if ($rezz === FALSE) {
        return $the_content;
    }
    if(isset($matches[1][0]))
    {
        $two_var_functions = array('pdfomatic');
        $three_var_functions = array('bhomatic', 'crawlomatic', 'dmomatic', 'ezinomatic', 'fbomatic', 'flickomatic', 'imguromatic', 'iui', 'instamatic', 'linkedinomatic', 'mediumomatic', 'pinterestomatic', 'echo', 'spinomatic', 'tumblomatic', 'wordpressomatic', 'wpcomomatic', 'youtubomatic', 'mastermind', 'businessomatic');
        $four_var_functions = array('contentomatic', 'quoramatic', 'newsomatic', 'aliomatic', 'amazomatic', 'blogspotomatic', 'bookomatic', 'careeromatic', 'cbomatic', 'cjomatic', 'craigomatic', 'ebayomatic', 'etsyomatic', 'rakutenomatic', 'learnomatic', 'eventomatic', 'gameomatic', 'gearomatic', 'giphyomatic', 'gplusomatic', 'hackeromatic', 'imageomatic', 'midas', 'movieomatic', 'nasaomatic', 'ocartomatic', 'okomatic', 'playomatic', 'recipeomatic', 'redditomatic', 'soundomatic', 'mp3omatic', 'ticketomatic', 'tmomatic', 'trendomatic', 'tuneomatic', 'twitchomatic', 'twitomatic', 'vimeomatic', 'viralomatic', 'vkomatic', 'walmartomatic', 'wikiomatic', 'xlsxomatic', 'yelpomatic', 'yummomatic');
        for ($i = 0; $i < count($matches[1]); $i++)
        {
            $replace_me = false;
            if(in_array($matches[1][$i], $four_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 4)
                    {  
                        $rule_runner = $za_function($matches[3][$i], $matches[2][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $three_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 3)
                    {
                        $rule_runner = $za_function($matches[3][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $two_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 2)
                    {
                        $rule_runner = $za_function($matches[3][$i], 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            if($replace_me == false)
            {
                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
            }
        }
    }
    return $the_content;
}
function ucomments_replaceYVACPostShortcodes($content, $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz)
{
    $matches = array();
    $i = 0;
    preg_match_all('~%regex\(\s*\"([^"]+?)\s*"\s*,\s*\"([^"]*)\"\s*(?:,\s*\"([^"]*?)\s*\")?(?:,\s*\"([^"]*?)\s*\")?(?:,\s*\"([^"]*?)\s*\")?\)%~si', $content, $matches);
    if (is_array($matches) && count($matches) && is_array($matches[0])) {
        for($i = 0; $i < count($matches[0]); $i++)
        {
            if (isset($matches[0][$i])) $fullmatch = $matches[0][$i];
            if (isset($matches[1][$i])) $search_in = ucomments_replaceYVACPostShortcodes($matches[1][$i], $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz);
            if (isset($matches[2][$i])) $matchpattern = $matches[2][$i];
            if (isset($matches[3][$i])) $element = $matches[3][$i];
            if (isset($matches[4][$i])) $delimeter = $matches[4][$i];if (isset($matches[5][$i])) $counter = $matches[5][$i];
            if (isset($matchpattern)) {
               if (preg_match('<^[\/#%+~[\]{}][\s\S]*[\/#%+~[\]{}]$>', $matchpattern, $z)) {
                  $ret = preg_match_all($matchpattern, $search_in, $submatches, PREG_PATTERN_ORDER);
               }
               else {
                  $ret = preg_match_all('~'.$matchpattern.'~si', $search_in, $submatches, PREG_PATTERN_ORDER);
               }
            }
            if (isset($submatches)) {
               if (is_array($submatches)) {
                  $empty_elements = array_keys($submatches[0], "");
                  foreach ($empty_elements as $e) {
                     unset($submatches[0][$e]);
                  }
                  $submatches[0] = array_unique($submatches[0]);
                  if (!is_numeric($element)) {
                     $element = 0;
                  }if (!is_numeric($counter)) {
                     $counter = 0;
                  }
                  if(isset($submatches[(int)($element)]))
                  {
                      $matched = $submatches[(int)($element)];
                  }
                  else
                  {
                      $matched = '';
                  }
                  $matched = array_unique((array)$matched);
                  if (empty($delimeter) || $delimeter == 'null') {
                     if (isset($matched[$counter])) $matched = $matched[$counter];
                  }
                  else {
                     $matched = implode($delimeter, $matched);
                  }
                  if (empty($matched)) {
                     $content = str_replace($fullmatch, '', $content);
                  } else {
                     $content = str_replace($fullmatch, $matched, $content);
                  }
               }
            }
        }
    }
    $spintax = new uComment_Spintax();
    $content = $spintax->process($content);
    $pcxxx = explode('<!??? template ???>', $content);
    $content = $pcxxx[array_rand($pcxxx)];
    $content = str_replace('%%random_sentence%%', ucomments_random_sentence_generator(), $content);
    $content = str_replace('%%random_sentence2%%', ucomments_random_sentence_generator(false), $content);
    $content = ucomments_replaceSynergyShortcodes($content);
    $content = str_replace('%%post_link%%', $post_link, $content);
    $content = str_replace('%%post_title%%', $post_title, $content);
    $content = str_replace('%%blog_title%%', $blog_title, $content);
    $content = str_replace('%%post_excerpt%%', $post_excerpt, $content);
    $content = str_replace('%%post_content%%', $post_content, $content);
    $content = str_replace('%%author_name%%', $user_name, $content);
    $content = str_replace('%%featured_image%%', $featured_image, $content);
    $content = str_replace('%%post_cats%%', $post_cats, $content);
    $content = str_replace('%%post_tags%%', $post_tagz, $content);
    return $content;
}

function ucomments_spin_text($title, $content, $alt = false)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . ' ' . $titleSeparator . ' ' . $content;
    $text                   = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        require_once(dirname(__FILE__) . "/res/ucomment-text-spinner.php");
        $phpTextSpinner = new PhpTextSpinner();
        if ($alt === FALSE) {
            $spinContent = $phpTextSpinner->spinContent($text);
        } else {
            $spinContent = $phpTextSpinner->spinContentAlt($text);
        }
        $translated = $phpTextSpinner->runTextSpinner($spinContent);
    }
    catch (Exception $e) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Exception thrown in spinText ' . $e->getMessage());
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}


function ucomments_best_spin_text($title, $content)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (!isset($ucomments_Comment_Settings['best_user']) || $ucomments_Comment_Settings['best_user'] == '' || !isset($ucomments_Comment_Settings['best_password']) || $ucomments_Comment_Settings['best_password'] == '') {
        ucomments_log_to_file('Please insert a valid "The Best Spinner" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $newhtml             = $title . ' ' . $titleSeparator . ' ' . $content;
    $url              = 'http://thebestspinner.com/api.php';
    $data             = array();
    $data['action']   = 'authenticate';
    $data['format']   = 'php';
    $data['username'] = $ucomments_Comment_Settings['best_user'];
    $data['password'] = $ucomments_Comment_Settings['best_password'];
    $ch               = curl_init();
    if ($ch === FALSE) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Failed to init curl!');
        }
        return FALSE;
    }
	if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
		curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
		if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
		}
	}
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    $fdata = "";
    foreach ($data as $key => $val) {
        $fdata .= "$key=" . urlencode($val) . "&";
    }
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_REFERER, $url);
    $html = curl_exec($ch);
    curl_close($ch);
    if ($html === FALSE) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('"The Best Spinner" failed to exec curl.');
        }
        return FALSE;
    }
    $output = unserialize($html);
    if ($output['success'] == 'true') {
        $session                = $output['session'];
        $data                   = array();
        $data['session']        = $session;
        $data['format']         = 'php';
        $data['protectedterms'] = '';
        $data['action']         = 'replaceEveryonesFavorites';
        $data['maxsyns']        = '100';
        $data['quality']        = '1';
        $ch = curl_init();
        if ($ch === FALSE) {
            if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                ucomments_log_to_file('Failed to init curl');
            }
            return FALSE;
        }
        $newhtml = html_entity_decode($newhtml);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, $url);
        $spinned = '';
        if(str_word_count($newhtml) > 4000)
        {
            while($newhtml != '')
            {
                $first30k = substr($newhtml, 0, 30000);
                $first30k = rtrim($first30k, '(*');
                $first30k = ltrim($first30k, ')*');
                $newhtml = substr($newhtml, 30000);
                $data['text']           = $first30k;
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode($val) . "&";
                }
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                $output = curl_exec($ch);
                if ($output === FALSE) {
                    if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                        ucomments_log_to_file('"The Best Spinner" failed to exec curl after auth.');
                    }
                    return FALSE;
                }
                $output = unserialize($output);
                if ($output['success'] == 'true') {
                    $spinned .= ' ' . $output['output'];
                } else {
                    if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                        ucomments_log_to_file('"The Best Spinner" failed to spin article.');
                    }
                    return FALSE;
                }
            }
        }
        else
        {
            $data['text'] = $newhtml;
            $fdata = "";
            foreach ($data as $key => $val) {
                $fdata .= "$key=" . urlencode($val) . "&";
            }
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
            $output = curl_exec($ch);
            if ($output === FALSE) {
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('"The Best Spinner" failed to exec curl after auth.');
                }
                return FALSE;
            }
            $output = unserialize($output);
            if ($output['success'] == 'true') {
                $spinned = $output['output'];
            } else {
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('"The Best Spinner" failed to spin article: ' . print_r($output, true));
                }
                return FALSE;
            }
        }
        curl_close($ch);
        $result = explode($titleSeparator, $spinned);
        if (count($result) < 2) {
            if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                ucomments_log_to_file('"The Best Spinner" failed to spin article - titleseparator not found.' . print_r($output, true));
            }
            return FALSE;
        }
        $spintax = new uComment_Spintax();
        $result[0] = $spintax->process($result[0]);
        $result[1] = $spintax->process($result[1]);
        return $result;

    } else {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('"The Best Spinner" authentification failed.');
        }
        return FALSE;
    }
}
class uComment_Spintax
{
    public function process($text)
    {
        return stripslashes(preg_replace_callback(
            '/\{(((?>[^\{\}]+)|(?R))*)\}/x',
            array($this, 'replace'),
            preg_quote($text)
        ));
    }
    public function replace($text)
    {
        $text = $this->process($text[1]);
        $parts = explode('|', $text);
        return $parts[array_rand($parts)];
    }
}

function ucomments_wordai_spin_text($title, $content)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (!isset($ucomments_Comment_Settings['best_user']) || $ucomments_Comment_Settings['best_user'] == '' || !isset($ucomments_Comment_Settings['best_password']) || $ucomments_Comment_Settings['best_password'] == '') {
        ucomments_log_to_file('Please insert a valid "Wordai" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $quality = 'Readable';
    $html             = $title . ' ' . $titleSeparator . ' ' . $content;
    $email = $ucomments_Comment_Settings['best_user'];
    $pass = $ucomments_Comment_Settings['best_password'];
    $html = urlencode($html);
    $ch = curl_init('http://wordai.com/users/turing-api.php');
    if($ch === false)
    {
        ucomments_log_to_file('Failed to init curl in wordai spinning.');
        return FALSE;
    }
	if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
		curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
		if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
		}
	}
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_POST, 1);
    curl_setopt ($ch, CURLOPT_POSTFIELDS, "s=$html&quality=$quality&email=$email&pass=$pass&output=json");
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    $result = curl_exec($ch);
    curl_close ($ch);
    if ($result === FALSE) {
        ucomments_log_to_file('"Wordai" failed to exec curl after auth.');
        return FALSE;
    }
    $result = json_decode($result);
    if(!isset($result->text))
    {
        ucomments_log_to_file('"Wordai" unrecognized response: ' . print_r($result, true));
        return FALSE;
    }
    $result = explode($titleSeparator, $result->text);
    if (count($result) < 2) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('"Wordai" failed to spin article - titleseparator not found.');
        }
        return FALSE;
    }
    $spintax = new uComment_Spintax();
    $result[0] = $spintax->process($result[0]);
    $result[1] = $spintax->process($result[1]);
    return $result;
}

function ucomments_spinrewriter_spin_text($title, $content)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (!isset($ucomments_Comment_Settings['best_user']) || $ucomments_Comment_Settings['best_user'] == '' || !isset($ucomments_Comment_Settings['best_password']) || $ucomments_Comment_Settings['best_password'] == '') {
        ucomments_log_to_file('Please insert a valid "SpinRewriter" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '(19459000)';
    $quality = '50';
    $html             = $title . ' ' . $titleSeparator . ' ' . $content;
    if(str_word_count($html) > 4000)
    {
        return FALSE;
    }
	$data = array();
	$data['email_address'] = $ucomments_Comment_Settings['best_user'];
	$data['api_key'] = $ucomments_Comment_Settings['best_password'];
	$data['action'] = "unique_variation";
	$data['text'] = $html;
	 
	$data['auto_protected_terms'] = "false";					
	$data['confidence_level'] = "high";							
	$data['auto_sentences'] = "true";							
	$data['auto_paragraphs'] = "true";							
	$data['auto_new_paragraphs'] = "false";						
	$data['auto_sentence_trees'] = "false";						
	$data['use_only_synonyms'] = "false";						
	$data['reorder_paragraphs'] = "false";						
	$data['nested_spintax'] = "false";							
    $api_response = ucomments_spinrewriter_api_post($data);
    if ($api_response === FALSE) {
        ucomments_log_to_file('"SpinRewriter" failed to exec curl after auth.');
        return FALSE;
    }
    $api_response = json_decode($api_response);
    if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
    {
        if(isset($api_response->status) && $api_response->status == 'ERROR')
        {
            if(isset($api_response->response) && $api_response->response == 'You can only submit entirely new text for analysis once every 7 seconds.')
            {
                $api_response = ucomments_spinrewriter_api_post($data);
                if ($api_response === FALSE) {
                    ucomments_log_to_file('"SpinRewriter" failed to exec curl after auth (after resubmit).');
                    return FALSE;
                }
                $api_response = json_decode($api_response);
                if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
                {
                    ucomments_log_to_file('"SpinRewriter" failed to wait and resubmit spinning: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                    return FALSE;
                }
            }
            else
            {
                ucomments_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                return FALSE;
            }
        }
        else
        {
            ucomments_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
            return FALSE;
        }
    }
    $api_response->response = urldecode($api_response->response);
    $result = explode($titleSeparator, $api_response->response);
    if (count($result) < 2) {
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('"SpinRewriter" failed to spin article - titleseparator not found: ' . $api_response->response);
        }
        return FALSE;
    }
    return $result;
}
function ucomments_spinrewriter_api_post($data){
	$ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
	$data_raw = "";
    
    $GLOBALS['wp_object_cache']->delete('crspinrewriter_spin_time', 'options');
    $spin_time = get_option('crspinrewriter_spin_time', false);
    if($spin_time !== false && is_numeric($spin_time))
    {
        $c_time = time();
        $spassed = $c_time - $spin_time;
        if($spassed < 10 && $spassed >= 0)
        {
            sleep(10 - $spassed);
        }
    }
    update_option('crspinrewriter_spin_time', time());
    
	foreach ($data as $key => $value){
		$data_raw = $data_raw . $key . "=" . urlencode($value) . "&";
	}
	$ch = curl_init();
    if($ch === false)
    {
        return false;
    }
	if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
		curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
		if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
		}
	}
	curl_setopt($ch, CURLOPT_URL, "http://www.spinrewriter.com/action/api");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data_raw);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
	$response = trim(curl_exec($ch));
	curl_close($ch);
	return $response;
}
function ucomments_replaceExecludes($article, &$htmlfounds, $opt = false)
{
    $htmlurls = array();$article = preg_replace('{data-image-description="(?:[^\"]*?)"}i', '', $article);
	if($opt === true){
		preg_match_all( "/<a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>(.*?)<\/a>/s" ,$article,$matches,PREG_PATTERN_ORDER);
		$htmlurls=$matches[0];
	}
	$urls_txt = array();
	if($opt === true){
		preg_match_all('/https?:\/\/[^<\s]+/', $article,$matches_urls_txt);
		$urls_txt = $matches_urls_txt[0];
	}
	preg_match_all("/<[^<>]+>/is",$article,$matches,PREG_PATTERN_ORDER);
	$htmlfounds=$matches[0];
	preg_match_all('{\[nospin\].*?\[/nospin\]}s', $article,$matches_ns);
	$nospin = $matches_ns[0];
	$pattern="\[.*?\]";
	preg_match_all("/".$pattern."/s",$article,$matches2,PREG_PATTERN_ORDER);
	$shortcodes=$matches2[0];
	preg_match_all("/<script.*?<\/script>/is",$article,$matches3,PREG_PATTERN_ORDER);
	$js=$matches3[0];
	preg_match_all('/\d{2,}/s', $article,$matches_nums);
	$nospin_nums = $matches_nums[0];
	sort($nospin_nums);
	$nospin_nums = array_reverse($nospin_nums);
	$capped = array();
	if($opt === true){
		preg_match_all("{\b[A-Z][a-z']+\b[,]?}", $article,$matches_cap);
		$capped = $matches_cap[0];
		sort($capped);
		$capped=array_reverse($capped);
	}
	$curly_quote = array();
	if($opt === true){
		preg_match_all('{???.*????}', $article, $matches_curly_txt);
		$curly_quote = $matches_curly_txt[0];
		preg_match_all('{???.*????}', $article, $matches_curly_txt_s);
		$single_curly_quote = $matches_curly_txt_s[0];
		preg_match_all('{&quot;.*?&quot;}', $article, $matches_curly_txt_s_and);
		$single_curly_quote_and = $matches_curly_txt_s_and[0];
		preg_match_all('{&#8220;.*?&#8221}', $article, $matches_curly_txt_s_and_num);
		$single_curly_quote_and_num = $matches_curly_txt_s_and_num[0];
		$curly_quote_regular = array();
		preg_match_all('{".*?"}', $article, $matches_curly_txt_regular);
        $curly_quote_regular = $matches_curly_txt_regular[0];
		$curly_quote = array_merge($curly_quote , $single_curly_quote ,$single_curly_quote_and,$single_curly_quote_and_num,$curly_quote_regular);
	}
	$htmlfounds = array_merge($nospin, $shortcodes, $js, $htmlurls, $htmlfounds, $curly_quote, $urls_txt, $nospin_nums, $capped);
	$htmlfounds = array_filter(array_unique($htmlfounds));
	$i=1;
	foreach($htmlfounds as $htmlfound){
		$article=str_replace($htmlfound,'('.str_repeat('*', $i).')',$article);	
		$i++;
	}
    $article = str_replace(':(*', ': (*', $article);
	return $article;
}
function ucomments_restoreExecludes($article, $htmlfounds){
	$i=1;
	foreach($htmlfounds as $htmlfound){
		$article=str_replace( '('.str_repeat('*', $i).')', $htmlfound, $article);
		$i++;
	}
	$article = str_replace(array('[nospin]','[/nospin]'), '', $article);
    $article = preg_replace('{\(?\*[\s*]+\)?}', '', $article);
	return $article;
}
function ucomments_fix_spinned_content($final_content, $spinner)
{
    if ($spinner == 'wordai') {
        $final_content = str_replace('-LRB-', '(', $final_content);
        $final_content = preg_replace("/{\*\|.*?}/", '*', $final_content);
        preg_match_all('/{\)[^}]*\|\)[^}]*}/', $final_content, $matches_brackets);
        $matches_brackets = $matches_brackets[0];
        foreach ($matches_brackets as $matches_bracket) {
            $matches_bracket_clean = str_replace( array('{','}') , '', $matches_bracket);
            $matches_bracket_parts = explode('|',$matches_bracket_clean);
            $final_content = str_replace($matches_bracket, $matches_bracket_parts[0], $final_content);
        }
    }
    elseif ($spinner == 'spinrewriter' || $spinner == 'translate') {
        $final_content = preg_replace('{\(\s(\**?\))\.}', '($1', $final_content);
        $final_content = preg_replace('{\(\s(\**?\))\s\(}', '($1(', $final_content);
        $final_content = preg_replace('{\s(\(\**?\))\.(\s)}', "$1$2", $final_content);
        $final_content = str_replace('( *', '(*', $final_content);
        $final_content = str_replace('* )', '*)', $final_content);
        $final_content = str_replace('& #', '&#', $final_content);
        $final_content = str_replace('& ldquo;', '"', $final_content);
        $final_content = str_replace('& rdquo;', '"', $final_content);
    }
    return $final_content;
}
function ucomments_spin_and_translate($post_title, $final_content)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    $ucomments_Comment_Settings = get_option('ucomments_Comment_Settings', false);
    if (isset($ucomments_Comment_Settings['spin_text']) && $ucomments_Comment_Settings['spin_text'] !== 'disabled') {
        
        $htmlfounds = array();
        $final_content = ucomments_replaceExecludes($final_content, $htmlfounds, false);
        
        
        if ($ucomments_Comment_Settings['spin_text'] == 'builtin') {
            $translation = ucomments_builtin_spin_text($post_title, $final_content);
        } elseif ($ucomments_Comment_Settings['spin_text'] == 'wikisynonyms') {
            $translation = ucomments_spin_text($post_title, $final_content, false);
        } elseif ($ucomments_Comment_Settings['spin_text'] == 'freethesaurus') {
            $translation = ucomments_spin_text($post_title, $final_content, true);
        } elseif ($ucomments_Comment_Settings['spin_text'] == 'best') {
            $translation = ucomments_best_spin_text($post_title, $final_content);
        } elseif ($ucomments_Comment_Settings['spin_text'] == 'wordai') {
            $translation = ucomments_wordai_spin_text($post_title, $final_content);
        } elseif ($ucomments_Comment_Settings['spin_text'] == 'spinrewriter') {
            $translation = ucomments_spinrewriter_spin_text($post_title, $final_content);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                $post_title    = $translation[0];
                $final_content = $translation[1];
                
                $final_content = ucomments_fix_spinned_content($final_content, $ucomments_Comment_Settings['spin_text']);
                $final_content = ucomments_restoreExecludes($final_content, $htmlfounds);
                
            } else {
                $final_content = ucomments_restoreExecludes($final_content, $htmlfounds);
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('Text Spinning failed - malformed data ' . $ucomments_Comment_Settings['spin_text']);
                }
            }
        } else {
            $final_content = ucomments_restoreExecludes($final_content, $htmlfounds);
            if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                ucomments_log_to_file('Text Spinning Failed - returned false ' . $ucomments_Comment_Settings['spin_text']);
            }
        }
    }
    if (isset($ucomments_Comment_Settings['translate']) && $ucomments_Comment_Settings['translate'] != 'disabled') {
        if(isset($ucomments_Comment_Settings['translate_source']) && $ucomments_Comment_Settings['translate_source'] != '')
        {
            $tr = $ucomments_Comment_Settings['translate_source'];
        }
        else
        {
            $tr = 'auto';
        }
        $htmlfounds = array();
        $final_content = ucomments_replaceExecludes($final_content, $htmlfounds, false);
        
        $translation = ucomments_translate($post_title, $final_content, $tr, $ucomments_Comment_Settings['translate']);
        if (is_array($translation) && isset($translation[1]))
        {
            $translation[1] = preg_replace('#(?<=[\*(])\s+(?=[\*)])#', '', $translation[1]);
            $translation[1] = preg_replace('#([^(*\s]\s)\*+\)#', '$1', $translation[1]);
            $translation[1] = preg_replace('#\(\*+([\s][^)*\s])#', '$1', $translation[1]);
            $translation[1] = ucomments_restoreExecludes($translation[1], $htmlfounds);
        }
        else
        {
            $final_content = ucomments_restoreExecludes($final_content, $htmlfounds);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                $post_title    = $translation[0];
                $final_content = $translation[1];
                $final_content = str_replace('</ iframe>', '</iframe>', $final_content);
                if(stristr($final_content, '<head>') !== false)
                {
                    $d = new DOMDocument;
                    $mock = new DOMDocument;
                    $internalErrors = libxml_use_internal_errors(true);
                    $d->loadHTML('<?xml encoding="utf-8" ?>' . $final_content);
                    libxml_use_internal_errors($internalErrors);
                    $body = $d->getElementsByTagName('body')->item(0);
                    foreach ($body->childNodes as $child)
                    {
                        $mock->appendChild($mock->importNode($child, true));
                    }
                    $new_post_content_temp = $mock->saveHTML();
                    if($new_post_content_temp !== '' && $new_post_content_temp !== false)
                    {
						$new_post_content_temp = str_replace('<?xml encoding="utf-8" ?>', '', $new_post_content_temp);
                        $final_content = preg_replace("/_addload\(function\(\){([^<]*)/i", "", $new_post_content_temp); 
                    }
                }
                $final_content = htmlspecialchars_decode($final_content);
                $final_content = str_replace('</ ', '</', $final_content);
                $final_content = str_replace(' />', '/>', $final_content);
                $final_content = str_replace('< br/>', '<br/>', $final_content);
                $final_content = str_replace('< / ', '</', $final_content);
                $final_content = str_replace(' / >', '/>', $final_content);
                $final_content = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $final_content);
                $post_title = preg_replace('{&\s*#\s*(\d+)\s*;}', '&#$1;', $post_title);
$post_title = htmlspecialchars_decode($post_title);
                $post_title = str_replace('</ ', '</', $post_title);
                $post_title = str_replace(' />', '/>', $post_title);
                $post_title = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $post_title);
            } else {
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('Translation failed - malformed data!');
                }
            }
        } else {
            if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                ucomments_log_to_file('Translation Failed - returned false!');
            }
        }
    }
    return array(
        $post_title,
        $final_content
    );
}

function ucomments_translate($title, $content, $from, $to)
{
    $ch                     = FALSE;
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    try {
        if($from == 'disabled')
        {
            $from = 'auto';
        }
        if($from != 'en' && $from == $to)
        {
            $from = 'en';
        }
        elseif($from == 'en' && $from == $to)
        {
            return false;
        }
        if (isset($ucomments_Main_Settings['google_trans_auth']) && trim($ucomments_Main_Settings['google_trans_auth']) != '')
        {
            require_once(dirname(__FILE__) . "/res/translator-api.php");
            $ch = curl_init();
            if ($ch === FALSE) {
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('Failed to init cURL in translator!');
                }
                return false;
            }
            if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
                if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
                    curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
                }
            }
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 10);
            $GoogleTranslatorAPI = new GoogleTranslatorAPI($ch, $ucomments_Main_Settings['google_trans_auth']);
            $translated = '';
            $translated_title = '';
            if($content != '')
            {
                if(strlen($content) > 30000)
                {
                    while($content != '')
                    {
                        $first30k = substr($content, 0, 30000);
                        $content = substr($content, 30000);
                        $translated_temp       = $GoogleTranslatorAPI->translateText($first30k, $from, $to);
                        $translated .= ' ' . $translated_temp;
                    }
                }
                else
                {
                    $translated       = $GoogleTranslatorAPI->translateText($content, $from, $to);
                }
            }
            if($title != '')
            {
                $translated_title = $GoogleTranslatorAPI->translateText($title, $from, $to);
            }
            curl_close($ch);
        }
        else
        {
            require_once(dirname(__FILE__) . "/res/ucomment-translator.php");
            $ch = curl_init();
            if ($ch === FALSE) {
                if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
                    ucomments_log_to_file('Failed to init cURL in translator!');
                }
                return false;
            }
            if (isset($ucomments_Main_Settings['proxy_url']) && $ucomments_Main_Settings['proxy_url'] != '') {
                curl_setopt($ch, CURLOPT_PROXY, $ucomments_Main_Settings['proxy_url']);
                if (isset($ucomments_Main_Settings['proxy_auth']) && $ucomments_Main_Settings['proxy_auth'] != '') {
                    curl_setopt($ch, CURLOPT_PROXYUSERPWD, $ucomments_Main_Settings['proxy_auth']);
                }
            }
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            curl_setopt($ch, CURLOPT_USERAGENT, ucomments_get_random_user_agent());
            $GoogleTranslator = new GoogleTranslator($ch);
            $translated = '';
            $translated_title = '';
            if($content != '')
            {
                if(strlen($content) > 13000)
                {
                    while($content != '')
                    {
                        $first30k = substr($content, 0, 13000);
                        $content = substr($content, 13000);
                        $translated_temp       = $GoogleTranslator->translateText($first30k, $from, $to);
                        if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                            throw new Exception('Page content already in ' . $to);
                        }
                        if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                            throw new Exception('Unexpected error while translating page!');
                        }
                        if(substr_compare($translated_temp, '</pre>', -strlen('</pre>')) === 0){$translated_temp = substr_replace($translated_temp ,"", -6);}if(substr( $translated_temp, 0, 5 ) === "<pre>"){$translated_temp = substr($translated_temp, 5);}
                        $translated .= ' ' . $translated_temp;
                    }
                }
                else
                {
                    $translated       = $GoogleTranslator->translateText($content, $from, $to);
                    if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                        throw new Exception('Page content already in ' . $to);
                    }
                    if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                        throw new Exception('Unexpected error while translating page!');
                    }
                }
            }
            if($title != '')
            {
                $translated_title = $GoogleTranslator->translateText($title, $from, $to);
            }
            if (strpos($translated_title, '<h2>The page you have attempted to translate is already in ') !== false) {
                throw new Exception('Page title already in ' . $to);
            }
            if (strpos($translated_title, 'Error 400 (Bad Request)!!1') !== false) {
                throw new Exception('Unexpected error while translating page title!');
            }
            curl_close($ch);
        }
    }
    catch (Exception $e) {
        curl_close($ch);
        if (isset($ucomments_Main_Settings['enable_detailed_logging'])) {
            ucomments_log_to_file('Exception thrown in GoogleTranslator ' . $e->getMessage());
        }
        return false;
    }
    if(substr_compare($translated_title, '</pre>', -strlen('</pre>')) === 0){$title = substr_replace($translated_title ,"", -6);}else{$title = $translated_title;}if(substr( $title, 0, 5 ) === "<pre>"){$title = substr($title, 5);}
    if(substr_compare($translated, '</pre>', -strlen('</pre>')) === 0){$text = substr_replace($translated ,"", -6);}else{$text = $translated;}if(substr( $text, 0, 5 ) === "<pre>"){$text = substr($text, 5);}
    $text  = preg_replace('/' . preg_quote('html lang=') . '.*?' . preg_quote('>') . '/', '', $text);
    $text  = preg_replace('/' . preg_quote('!DOCTYPE') . '.*?' . preg_quote('<') . '/', '', $text);
    $text  = preg_replace('#https:\/\/translate\.google\.com\/translate\?hl=en&amp;prev=_t&amp;sl=en&amp;tl=pl&amp;u=([^><"\'\s\n]*)#i', urldecode('$1'), $text);
    $text  = preg_replace('#%3Fenablejsapi%3D\d#i', '', $text);
    $text  = preg_replace('#%26origin%3D[^<&?>\'\s\n"]*#i', '', $text);
    $text  = preg_replace('#%26hl%3D(disabled|[a-z][a-z])#i', '', $text);
    $text  = preg_replace('#%3Fcontrols%3D\d#i', '', $text);
    return array(
        $title,
        $text
    );
}

register_activation_hook(__FILE__, 'ucomments_check_version');
function ucomments_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'ucomment-wordpress-blog-auto-commenter').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . esc_html__('You are not allowed to activate plugins!', 'ucomment-wordpress-blog-auto-commenter') . '</p>';
        die;
    }
    $php_version_required = '5.4';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'ucomment-wordpress-blog-auto-commenter'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'ucomment-wordpress-blog-auto-commenter'), $wp_version_required) . '</p>';
        die;
    }
}

add_action('admin_init', 'ucomments_register_mysettings');
function ucomments_register_mysettings()
{
    ucomments_cron_schedule();
    register_setting('ucomments_option_group', 'ucomments_Main_Settings');
    register_setting('ucomments_option_group2', 'ucomments_Comment_Settings');
    if (is_multisite()) {
        if (!get_option('ucomments_Main_Settings')) {
            ucomments_activation_callback(TRUE);
        }
    }
}

function ucomments_admin_load_files()
{
    wp_register_style('ucomment-browser-style', plugins_url('styles/ucomment-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('ucomment-browser-style');
    wp_register_style('ucomments-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('ucomments-custom-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
}

function ucomments_random_sentence_generator($first = true)
{
    $ucomments_Main_Settings = get_option('ucomments_Main_Settings', false);
    if ($first == false) {
        $r_sentences = $ucomments_Main_Settings['sentence_list2'];
    } else {
        $r_sentences = $ucomments_Main_Settings['sentence_list'];
    }
    $r_variables = $ucomments_Main_Settings['variable_list'];
    $r_sentences = trim($r_sentences);
    $r_variables = trim($r_variables, ';');
    $r_variables = trim($r_variables);
    $r_sentences = str_replace("\r\n", "\n", $r_sentences);
    $r_sentences = str_replace("\r", "\n", $r_sentences);
    $r_sentences = explode("\n", $r_sentences);
    $r_variables = str_replace("\r\n", "\n", $r_variables);
    $r_variables = str_replace("\r", "\n", $r_variables);
    $r_variables = explode("\n", $r_variables);
    $r_vars      = array();
    for ($x = 0; $x < count($r_variables); $x++) {
        $var = explode("=>", trim($r_variables[$x]));
        if (isset($var[1])) {
            $key          = strtolower(trim($var[0]));
            $words        = explode(";", trim($var[1]));
            $r_vars[$key] = $words;
        }
    }
    $max_s    = count($r_sentences) - 1;
    $rand_s   = rand(0, $max_s);
    $sentence = $r_sentences[$rand_s];
    $sentence = str_replace(' ,', ',', ucfirst(ucomments_replace_words($sentence, $r_vars)));
    $sentence = str_replace(' .', '.', $sentence);
    $sentence = str_replace(' !', '!', $sentence);
    $sentence = str_replace(' ?', '?', $sentence);
    $sentence = trim($sentence);
    return $sentence;
}

function ucomments_get_word($key, $r_vars)
{
    if (isset($r_vars[$key])) {
        
        $words  = $r_vars[$key];
        $w_max  = count($words) - 1;
        $w_rand = rand(0, $w_max);
        return ucomments_replace_words(trim($words[$w_rand]), $r_vars);
    } else {
        return "";
    }
    
}

function ucomments_replace_words($sentence, $r_vars)
{
    
    if (str_replace('%', '', $sentence) == $sentence)
        return $sentence;
    
    $words = explode(" ", $sentence);
    
    $new_sentence = array();
    for ($w = 0; $w < count($words); $w++) {
        
        $word = trim($words[$w]);
        
        if ($word != '') {
            if (preg_match('/^%([^%\n]*)$/', $word, $m)) {
                $varkey         = trim($m[1]);
                $new_sentence[] = ucomments_get_word($varkey, $r_vars);
            } else {
                $new_sentence[] = $word;
            }
        }
    }
    return implode(" ", $new_sentence);
}
require(dirname(__FILE__) . "/res/ucomment-main.php");
require(dirname(__FILE__) . "/res/ucomment-wp-list.php");
require(dirname(__FILE__) . "/res/ucomment-logs.php");
?>